config/routes.rb
# config/routes.rb
Rails.application.routes.draw do
  resources :articles do
    resources :comments
  end

  root 'articles#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/article.rb
# app/models/article.rb
class Article < ApplicationRecord
    has_many :comments, dependent: :destroy
  
    enum status: { draft: 0, published: 1, archived: 2 }
  
    validates :title, :content, presence: true
  end
  

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :article
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  before_action :set_article, only: %i[ show edit update destroy ]

  # GET /articles or /articles.json
  def index
    @articles = Article.all
  end

  # GET /articles/1 or /articles/1.json
  def show
  end

  # GET /articles/new
  def new
    @article = Article.new
  end

  # GET /articles/1/edit
  def edit
  end

  # POST /articles or /articles.json
  def create
    @article = Article.new(article_params)

    respond_to do |format|
      if @article.save
        format.html { redirect_to article_url(@article), notice: "Article was successfully created." }
        format.json { render :show, status: :created, location: @article }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @article.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /articles/1 or /articles/1.json
  def update
    respond_to do |format|
      if @article.update(article_params)
        format.html { redirect_to article_url(@article), notice: "Article was successfully updated." }
        format.json { render :show, status: :ok, location: @article }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @article.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /articles/1 or /articles/1.json
  def destroy
    @article.destroy!

    respond_to do |format|
      format.html { redirect_to articles_url, notice: "Article was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_article
      @article = Article.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def article_params
      params.require(:article).permit(:title, :content, :status)
    end
end
def new
  @article = Article.find(params[:article_id])
  @comment = Comment.new
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :set_comment, only: %i[ show edit update destroy ]

  # GET /comments or /comments.json
  def index
    @comments = Comment.all
  end

  # GET /comments/1 or /comments/1.json
  def show
  end

  # GET /comments/new
  def new
    @comment = Comment.new
  end

  # GET /comments/1/edit
  def edit
  end

  # POST /comments or /comments.json
  def create
    @comment = Comment.new(comment_params)

    respond_to do |format|
      if @comment.save
        format.html { redirect_to comment_url(@comment), notice: "Comment was successfully created." }
        format.json { render :show, status: :created, location: @comment }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /comments/1 or /comments/1.json
  def update
    respond_to do |format|
      if @comment.update(comment_params)
        format.html { redirect_to comment_url(@comment), notice: "Comment was successfully updated." }
        format.json { render :show, status: :ok, location: @comment }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /comments/1 or /comments/1.json
  def destroy
    @comment.destroy!

    respond_to do |format|
      format.html { redirect_to comments_url, notice: "Comment was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_comment
      @comment = Comment.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def comment_params
      params.require(:comment).permit(:commenter, :body, :article_id)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/views/articles/_article.html.erb
<div id="<%= dom_id article %>">
  <p>
    <strong>Title:</strong>
    <%= article.title %>
  </p>

  <p>
    <strong>Content:</strong>
    <%= article.content %>
  </p>

  <p>
    <strong>Status:</strong>
    <%= article.status %>
  </p>

</div>

app/views/articles/_form.html.erb
<%= form_with(model: article) do |form| %>
  <% if article.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(article.errors.count, "error") %> prohibited this article from being saved:</h2>

      <ul>
        <% article.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :title, style: "display: block" %>
    <%= form.text_field :title %>
  </div>

  <div>
    <%= form.label :content, style: "display: block" %>
    <%= form.text_area :content %>
  </div>

  <div>
    <%= form.label :status, style: "display: block" %>
    <%= form.number_field :status %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/articles/edit.html.erb
<h1>Editing article</h1>

<%= render "form", article: @article %>

<br>

<div>
  <%= link_to "Show this article", @article %> |
  <%= link_to "Back to articles", articles_path %>
</div>

app/views/articles/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Articles</h1>

<div id="articles">
  <% @articles.each do |article| %>
    <%= render article %>
    <p>
      <%= link_to "Show this article", article %>
    </p>
  <% end %>
</div>

<%= link_to "New article", new_article_path %>

app/views/articles/new.html.erb
<h1>New article</h1>

<%= render "form", article: @article %>

<br>

<div>
  <%= link_to "Back to articles", articles_path %>
</div>

app/views/articles/show.html.erb
<!-- app/views/articles/show.html.erb -->
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @article.title %>
</p>

<p>
  <strong>Content:</strong>
  <%= @article.content %>
</p>

<p>
  <strong>Status:</strong>
  <%= @article.status %>
</p>

<h2>Comments</h2>
<% @article.comments.each do |comment| %>
  <p>
    <strong>Commenter:</strong>
    <%= comment.commenter %>
  </p>
  <p>
    <strong>Comment:</strong>
    <%= comment.body %>
  </p>
<% end %>

<h2>Add a comment:</h2>
<%= form_with(model: [ @article, @article.comments.build ], local: true) do |form| %>
  <p>
    <%= form.label :commenter %><br>
    <%= form.text_field :commenter %>
  </p>
  <p>
    <%= form.label :body %><br>
    <%= form.text_area :body %>
  </p>
  <p>
    <%= form.submit %>
  </p>
<% end %>

<%= link_to 'Edit', edit_article_path(@article) %> |
<%= link_to 'Back', articles_path %>

app/views/comments/_comment.html.erb
<div id="<%= dom_id comment %>">
  <p>
    <strong>Commenter:</strong>
    <%= comment.commenter %>
  </p>

  <p>
    <strong>Body:</strong>
    <%= comment.body %>
  </p>

  <p>
    <strong>Article:</strong>
    <%= comment.article_id %>
  </p>

</div>

app/views/comments/_form.html.erb
<%= form_with(model: [ @article, comment], url: article_comments_path(@article)) do |form| %>
  <% if comment.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(comment.errors.count, "error") %> prohibited this comment from being saved:</h2>

      <ul>
        <% comment.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <p>
    <%= form.label :commenter %><br>
    <%= form.text_field :commenter %>
  </p>
  <p>
    <%= form.label :body %><br>
    <%= form.text_area :body %>
  </p>
  <p>
    <%= form.submit %>
  </p>
<% end %>

app/views/comments/edit.html.erb
<h1>Editing comment</h1>

<%= render "form", comment: @comment %>

<br>

<div>
  <%= link_to "Show this comment", @comment %> |
  <%= link_to "Back to comments", comments_path %>
</div>

app/views/comments/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Comments</h1>

<div id="comments">
  <% @comments.each do |comment| %>
    <%= render comment %>
    <p>
      <%= link_to "Show this comment", comment %>
    </p>
  <% end %>
</div>

<%= link_to "New comment", new_comment_path %>

app/views/comments/new.html.erb
<h1>New comment</h1>

<%= render "form", comment: @comment %>

<br>

<div>
  <%= link_to "Back to comments", comments_path %>
</div>

app/views/comments/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @comment %>

<div>
  <%= link_to "Edit this comment", edit_comment_path(@comment) %> |
  <%= link_to "Back to comments", comments_path %>

  <%= button_to "Destroy this comment", @comment, method: :delete %>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>SkeletalCms</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>